﻿local BMT_POPUP_FRAME_WIDTH_MIN = 100
local BMT_POPUP_FRAME_HEIGHT_MIN = 100

-- okay popup window state (clicking Okay triggers further necessary steps)
BMT_OKAY_WINDOW_STATE_NONE = 0
BMT_OKAY_WINDOW_STATE_OUTDATED_DATA_STRUCT = 1
local BMTOkayWindowState = BMT_OKAY_WINDOW_STATE_NONE
-- confirm popup window state (clicking Yes triggers further steps, clicking No resets it to 0)
BMT_CONFIRM_WINDOW_STATE_NONE = 0
BMT_CONFIRM_WINDOW_STATE_DELETE_ALL = 1
BMT_CONFIRM_WINDOW_STATE_DELETE_CURRENT = 2
BMTConfirmWindowState = BMT_CONFIRM_WINDOW_STATE_NONE

function BMTShowPopupWindowOkay(state, text)
	BMTHideAllPopupWindows()
	BMTPopupWindowOkay.Text:SetText(text);
	BMTPopupWindowOkay:Show();
	local textWidth = BMTPopupWindowOkay.Text:GetWidth();
	local textHeight = BMTPopupWindowOkay.Text:GetHeight();
	local width = textWidth + BMT_POPUP_FRAME_WIDTH_MIN;
	local height = textHeight + BMT_POPUP_FRAME_HEIGHT_MIN;
	BMTPopupWindowOkay:SetWidth(width);
	BMTPopupWindowOkay:SetHeight(height);
	BMTOkayWindowState = state;
end

function BMTPopupOnClick_Okay()
	if BMTOkayWindowState == BMT_OKAY_WINDOW_STATE_OUTDATED_DATA_STRUCT then
		BMT_DeleteAllData();
	end
	BMTOkayWindowState = BMT_OKAY_WINDOW_STATE_NONE;
end

function BMTShowPopupWindowConfirm(state, text)
	BMTHideAllPopupWindows()
	BMTPopupWindowConfirm.Text:SetText(text);
	BMTPopupWindowConfirm:Show();
	local textWidth = BMTPopupWindowConfirm.Text:GetWidth();
	local textHeight = BMTPopupWindowConfirm.Text:GetHeight();
	local width = textWidth + BMT_POPUP_FRAME_WIDTH_MIN;
	local height = textHeight + BMT_POPUP_FRAME_HEIGHT_MIN;
	BMTPopupWindowConfirm:SetWidth(width);
	BMTPopupWindowConfirm:SetHeight(height);
	BMTConfirmWindowState = state;
end

function BMTPopupConfirmOnClick_Yes()
	if BMT_CONFIRM_WINDOW_STATE_DELETE_ALL then
		BMT_DeleteAllData()
	elseif BMT_CONFIRM_WINDOW_STATE_DELETE_CURRENT then
		BMT_DeleteCurrentDB()
	end
	BMTConfirmWindowState = BMT_CONFIRM_WINDOW_STATE_NONE
end

function BMTPopupConfirmOnClick_No()
	BMTConfirmWindowState = BMT_CONFIRM_WINDOW_STATE_NONE
end

function BMTHideAllPopupWindows()
	if (BMTPopupWindowOkay:IsShown()) then
		BMTPopupWindowOkay:Hide();
	end
	if (BMTPopupWindowConfirm:IsShown()) then
		BMTPopupWindowConfirm:Hide();
	end
end

function BMTIsAnyPopupWindowShown()
	if (BMTPopupWindowOkay:IsShown() or BMTPopupWindowConfirm:IsShown()) then
		return true
	else
		return false
	end
end

function BMTMakeAllWindowsInteractive()
	BMTFrame:SetAlpha(1);
	BMTFrame:SetToplevel(true);
	BMTFrame:EnableMouse(true);
	BMTFrame.CloseButton:EnableMouse(true);
	BMT_EnableEscInteractivity("BMTFrame")
	local buttons = BMTScrollFrame.buttons;
	local numButtons = 0;
	if buttons ~= nil then
		numButtons = #buttons;
	end
	for i=1, numButtons do
		buttons[i]:EnableMouse(true);
		buttons[i].Item:EnableMouse(true);
		buttons[i].TimeLeft:EnableMouse(true);
	end
end

function BMTMakeAllWindowsNonInteractive()
	if (BMTFrame:IsShown()) then
		BMTFrame:SetAlpha(0.5);
		BMTFrame:SetToplevel(false);
		BMTFrame:EnableMouse(false);
		BMTFrame.CloseButton:EnableMouse(false);
		BMT_DisableEscInteractivity("BMTFrame")
	end
	local buttons = BMTScrollFrame.buttons;
	local numButtons = 0;
	if buttons ~= nil then
		numButtons = #buttons;
	end
	for i=1, numButtons do
		buttons[i]:EnableMouse(false);
		buttons[i].Item:EnableMouse(false);
		buttons[i].TimeLeft:EnableMouse(false);
	end
	
end
